%global okdiary_user_grp    okdiary
%global okdiary_dir         /var/lib/okdiary
%global _unitdir            %{_libdir}/systemd/system
%global cacert_src          /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem
%global cacert_dst          /etc/ssl/cert.pem

Name:       okdiary
Version:    %(cat version)
Release:    1%{?dist}
Summary:    Everyday journal web-app
License:    EUPL-1.2
URL:        http://www.nkly.me/projects/okdiary

Requires: ca-certificates

%description
OkDiary is a web application for keeping everyday journal.

%prep
%setup -q

%build
eval $(opam env)
make install-deps
make build-static man

%install
rm -rf %{buildroot}
#mkdir -p %{buildroot}/%{okdiary_dir}
install -s -D -m 0755 _build/default/src/okdiaryd/okdiaryd.exe %{buildroot}/%{_bindir}/okdiaryd
install -D -m 0644 man/okdiaryd.8.gz %{buildroot}/%{_mandir}/man8/okdiaryd.8.gz
install -D -m 0644 dist/okdiaryd.conf %{buildroot}/%{_sysconfdir}/okdiaryd.conf
install -D -m 0644 dist/okdiaryd.service %{buildroot}/%{_unitdir}/okdiaryd.service

%pre
getent group %{okdiary_user_grp} >/dev/null 2>&1 \
    || groupadd --system %{okdiary_user_grp}
getent passwd %{okdiary_user_grp} >/dev/null 2>&1 \
    || useradd --system \
               --create-home \
               --home-dir %{okdiary_dir} \
               --shell /sbin/nologin \
               --comment "OkDiary Daemon" \
               --gid %{okdiary_user_grp} \
               %{okdiary_user_grp}
mkdir -p "$(dirname %{cacert_dst})"
[[ "$(readlink %{cacert_dst})" == "%{cacert_src}" ]] || ln -s %{cacert_src} %{cacert_dst}

%post
chmod 0750 %{okdiary_dir}
if [ $1 -eq 1 ]; then
    echo
    echo "You've installed OkDiary for the first time. Congratulations!"
    echo "A couple of things needs to be done before running it though:"
    echo
    echo "* Open /etc/okdiaryd.conf in your favorite editor"
    echo "* Set BASE_URL to the external URL you're going to use to access OkDiary in a browser"
    echo "* Run 'okdiaryd generate-application-keys' to generate application keys"
    echo "* Replace empty *_KEY parameters with the newly generated application keys"
    echo
    echo "Once you've done these steps, you're ready to go. Enjoy!"
    echo
fi

%preun
# Disable service on removal
if [ $1 -eq 0 ]; then systemctl --no-reload disable --now okdiaryd.service; fi

%files
%{_bindir}/okdiaryd
%{_mandir}/man8/okdiaryd.8.gz
%{_unitdir}/okdiaryd.service
%config(noreplace) %{_sysconfdir}/okdiaryd.conf

%changelog
# See project changelog
