# NAME

okdiaryd - OkDiary web server and administration tool

# SYNOPSIS

**okdiaryd** _COMMAND_

# DESCRIPTION

**okdiaryd** is a program for serving and administering OkDiary web application.

# COMMANDS

**serve**
> Starts OkDiary HTTP-server.

**generate-application-keys**
> Generates new pairs of encryption and signing application keys used to
> authenticate application via external OkAuth server.

# ENVIRONMENT

_$DB_PATH_
> Path to a database file. Default: _okdiary.db_ file in the current working
> directory.

_$HOST_,
_$PORT_
> IP address and port to bind the HTTP-server to.

_$BASE_URL_
> URL to use in a browser to access OkDiary.

_$AUTH_BACKEND_
> Authentication backend to use. Supported backends are:

> _okauth_
> > (Default) Authenticate users via OkAuth.

> _dummy_
> > Does not perform any authentication. FOR DEVELOPMENT PURPOSES ONLY!

_$PUBLIC_ENCRYPTION_KEY_,
_$SECRET_ENCRYPTION_KEY_,
_$PUBLIC_SIGNING_KEY_,
_$SECRET_SIGNING_KEY_
> Application keys used for encryption and signing authentication requests to
> external OkAuth server.

# FILES

_okdiary.db_ (if $DB_PATH is unset)
> Database file that stores encrypted journal entries

# RESOURCES

**Project homepage:** http://www.nkly.me/projects/okdiary

# AUTHORS

Copyright (C) 2020 Nikolai Obedin.

Free use of this software is granted under the terms of EUPL-1.2.
